"""Class for the blocks that create the levels"""

import pygame

import os.path

class Block(pygame.sprite.Sprite):
    """Basic block, nothing special"""
    def __init__(self, vals, level):
        """vals must be a dictionary!"""
        self.__dict__.update(vals)
        self.level = level
        self.animate = eval(self.animate)
        if self.animate:
            self.animtime = eval(self.animtime)
            self.frames = eval(self.frames)
            self.frame = 0
        pygame.sprite.Sprite.__init__(self)
        
    def image(self):
        return self.level.tiles[self.img]
        
    def update(self):
        if self.animate == "true":
            if not self.animtime:
                self.next_frame()
                self.img = self.frames[self.frame]
                self.animtime = 16
            else:
                self.animtime -= 1
                
        if self.tag == "egg":
            if pygame.sprite.collide_rect(self, self.level.game.get_player()):
                p = self.level.game.get_player()
                p.element = self.element
                p.ragdoll.set_color(self.color)
                
    def next_frame(self):
        self.frame+=1
        if self.frame >= len(self.frames):
            self.frame = 0
        if self.frames[self.frame] == "stop":
            if self.tag == "wool":
                self.solid = "false"
            self.animate = "false"
            self.frame-=1
