"""Class to use a bitmap head for a ragdoll anim"""

import pygame

import math, os.path

import limb

class Head(limb.Limb):
    """Limb that draws a bitmap, such as a head"""
    def __init__(self, p1, p2, color):
        self.target = math.pi/2
        limb.Limb.__init__(self, p1, p2, 0, color, self.target)
        self.set_color(color)
        
    def update(self):
        diff = self.target - self.get_angle()
        self.rotate(diff)

    def draw(self, image):
        limb.Limb.draw(self, image)
        image.blit(pygame.transform.rotate(self.image, self.get_angle()), (6, 0))
        
    def set_color(self, color):
        self.image = pygame.image.load(os.path.normcase(os.path.normpath(\
            "res/chars/char-"+color+".png"))).convert_alpha()
        self.color = color
