"""A class to implement ragdolls so that the character class can focus on other game mechanics"""

import math, ConfigParser, os.path

import pygame

import entity, head, limb

class Ragdoll:
    """Takes care of the physics and animation for the Character class
    
    Needs to eventually take all of it's points from a .phys file, but I don't
    have the time"""
    def __init__(self, color, moves):
        self.moves = ConfigParser.SafeConfigParser()
        self.moves.readfp(open(os.path.normcase(os.path.normpath(moves))))
        self.color = color
        self.changetime = 8
        self.state = "standing"
        self.points = dict(self.moves.items(self.state))
        for point in self.points.items():
            self.points[point[0]] = eval(point[1])
            
    def update(self, state):
        if not self.changetime:
            if self.state == state:
                self.points = dict(self.moves.items(self.points["next"]))
            else:
                self.state = state
                self.points = dict(self.moves.items(state))
            for point in self.points.items():
                self.points[point[0]] = eval(point[1])
            self.changetime = 8
        else:
            self.changetime -=1
        
    def set_color(self, color):
        self.color = color
    
    def get_image(self):
        img =  pygame.Surface((32, 64), pygame.SRCALPHA, 32)
        img.fill(pygame.Color(0, 0, 0, 0))
        return img
        
    def draw(self):
        image = self.get_image()
        head = pygame.image.load(os.path.normcase(os.path.normpath("res/chars/"+self.color+".png"))).convert_alpha()
        image.blit(head, self.points["head"])
        pygame.draw.line(image, pygame.Color(self.color), self.points["neck"], self.points["hip"], 3)
        pygame.draw.line(image, pygame.Color(self.color), self.points["shoulder"], self.points["relbow"], 3)
        pygame.draw.line(image, pygame.Color(self.color), self.points["relbow"], self.points["rhand"], 3)
        pygame.draw.line(image, pygame.Color(self.color), self.points["shoulder"], self.points["lelbow"], 3)
        pygame.draw.line(image, pygame.Color(self.color), self.points["lelbow"], self.points["lhand"], 3)
        pygame.draw.line(image, pygame.Color(self.color), self.points["hip"], self.points["rknee"], 3)
        pygame.draw.line(image, pygame.Color(self.color), self.points["rknee"], self.points["rfoot"], 3)
        pygame.draw.line(image, pygame.Color(self.color), self.points["hip"], self.points["lknee"], 3)
        pygame.draw.line(image, pygame.Color(self.color), self.points["lknee"], self.points["lfoot"], 3)
        return image
